﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using System.Collections;

namespace howto_bitarray_extensions
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        // Demonstrate BitArray extensions.
        private void Form1_Load(object sender, EventArgs e)
        {
            // Make a BitArray holding IsSquare Xor IsFibonacci.
            BitArray bits = new BitArray(32);
            for (int i = 0; i < bits.Length; i++)
                bits[i] = (IsSquare(i) ^ IsFibonacci(i));

            // Display the result in various ways.
            string txt = "";
            txt += "# True: " + bits.NumTrue() + ", " +
                "# False: " + bits.NumFalse() + ", " +
                "AndAll: " + bits.AndAll() + ", " +
                "OrAll: " + bits.OrAll() +
                "\r\n";
            txt += bits.ToString("T", " ") + "\r\n";
            txt += bits.ToString("X", ".") + "\r\n";
            txt += bits.ToString("1", "0", "", 8, " ") + "\r\n";
            txt += bits.ToString("TRUE", "false", " ");
            txtBits.Text = txt;
            txtBits.Select(0, 0);
        }

        // Return true if i is a perfect square.
        private bool IsSquare(int i)
        {
            int sqrt_i = (int)Math.Sqrt(i);
            return (sqrt_i * sqrt_i == i);
        }

        // Return true if i is a Fibonacci number.
        private bool IsFibonacci(int i)
        {
            if (i == 0) return true;

            long fib_i_minus_1 = 0;
            long fib_i = 1;
            while (fib_i < i)
            {
                long fib_i_plus_1 = fib_i + fib_i_minus_1;
                fib_i_minus_1 = fib_i;
                fib_i = fib_i_plus_1;
            }
            return (i == fib_i);
        }
    }
}
